//+------------------------------------------------------------------+
//|                                           Find_pair_T101_v11.mq4 |
//|                                                        GrayMan77 |
//|                                                                  |
//|        T101:                        |
//|  -    ;                          |
//|  -        .       |
//|                                                                  |
//|  v11 -     .                 |
//|  |
//|  |
//+------------------------------------------------------------------+
#property copyright "GrayMan77"
#property link      ""

#property indicator_chart_window

//----  
extern int CorrelationBars=1000; //     
extern int SymbolsPerGroup=7;    //   

extern bool ReverseNZDGBP=true;

//---- 

//   ( -  !!!)
string Symbols[]={"EURUSD","GBPUSD","USDCHF","USDJPY","AUDUSD","USDCAD",
               "NZDUSD","EURGBP","EURCHF","EURJPY","EURAUD","EURCAD",
               "EURNZD","GBPCHF","GBPJPY","GBPAUD","GBPCAD","NZDGBP",
               "CHFJPY","AUDCHF","CADCHF","NZDCHF","AUDJPY","CADJPY",
               "NZDJPY","AUDCAD","AUDNZD","NZDCAD"};
bool NotCalculate;
int startTime,fihishTime;
bool Error;

double Correlation[28][28];
double iCloseSymbols[][28];  //   (1-  - ; 2- -  

int FindSymbols;
int NumbSymbGroup1[],NumbSymbGroup2[];
double StoreCorr[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  int i;
   
   Error=false;
   
   if(ReverseNZDGBP) Symbols[17]="GBPNZD";
   
   NotCalculate=true;
   
   //       
   ArrayResize(iCloseSymbols,CorrelationBars);
   ArrayResize(NumbSymbGroup1,SymbolsPerGroup);
   ArrayResize(NumbSymbGroup2,SymbolsPerGroup);
   ArrayResize(StoreCorr,SymbolsPerGroup);
  
//----
   return(0);
  }


//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   Comment("");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
  int counted_bars=IndicatorCounted();
  
  int i,j;
  double CorrMax;
  int Store_i,Store_j;
  string str1,str2,str3;
  
  
  //  
  if(Error || SymbolsPerGroup>14)
    {
    Print("   !");
    Alert("   !");
    return(-1);
    }
  
//----
  
  //   1 
  if(NotCalculate)
    {
    startTime=GetTickCount();
    
    // 
    ReadClose();
    
    //    (  )
    for(i=0;i<28;i++)
      {
      for(j=i+1;j<28;j++)
        {
        Correlation[i][j]=CorrTwoSymbols(i,j);
        }
      }
    
    //     
    FindSymbols=0.;
    while(FindSymbols<=SymbolsPerGroup)
      {
      CorrMax=-2.;
      for(i=0;i<28;i++)
        {
        for(j=i+1;j<28;j++)
          {
          if(Correlation[i][j]==-2.) continue;
          if(Correlation[i][j]>CorrMax)
            {
            CorrMax=Correlation[i][j];
            Store_i=i;
            Store_j=j;
            }
          }
        }
      NumbSymbGroup1[FindSymbols]=Store_i;
      NumbSymbGroup2[FindSymbols]=Store_j;
      StoreCorr[FindSymbols]=CorrMax;
      // ""       
      
      for(j=Store_i+1;j<28;j++) Correlation[Store_i][j]=-2.;
      for(j=Store_j+1;j<28;j++) Correlation[Store_j][j]=-2.;
      for(i=0;i<Store_j;i++) Correlation[i][Store_j]=-2.;
      for(i=0;i<Store_i;i++) Correlation[i][Store_i]=-2.;
      
      FindSymbols++;
      }
    
    //  
    str1="\n     101    v11 \n (C) GrayMan77 \n \n       1           2           \n";
    str2="----";
    str3="----";
    for(i=0; i<SymbolsPerGroup; i++)
      {
      str1=str1+" \n    "+Symbols[NumbSymbGroup1[i]]+"           "+Symbols[NumbSymbGroup2[i]]+"           "+DoubleToStr(StoreCorr[i],4);
      str2=str2+Symbols[NumbSymbGroup1[i]]+";";
      str3=str3+Symbols[NumbSymbGroup2[i]]+";";
      }
    
    Comment(str1);
    
    //   
    Print(str2);
    Print(str3);
    
    NotCalculate=false;

    //   
    fihishTime=GetTickCount();
    Print("  ",(fihishTime-startTime)/1000.," .");
    }
   
//----
  return(0);
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|    iCloseSymbols[][]  Close[]          |
//|   28-    LendhtChannelBars        |
//+------------------------------------------------------------------+
void ReadClose()
  {
  int i,j;
  datetime TimeBar;
  
  //   
  for(i=0; i<28; i++)
    {
    //   
    for(j=0; j<CorrelationBars; j++) // 0-   !!!
      {
      TimeBar=Time[j+1];
      iCloseSymbols[j][i]=iClose(Symbols[i],Period(),iBarShift(Symbols[i],Period(),TimeBar,false));
      }
    }
  /*
  for(i=0; i<28; i++)
    {
    Print("!!!!! ---- i=",i,"   Symbol=",Symbols[i],"    iCloseSymbols=",iCloseSymbols[0][i]);
    }
  */
  return;
  }
//+------------------------------------------------------

//+------------------------------------------------------------------+
//|                       |
//|  Symbol1  Symbol2.                                              |
//|      iCloseSymbols[][28].                     |
//|      - CorrelationBars.                 |
//+------------------------------------------------------------------+
double CorrTwoSymbols(int Symbol1,int Symbol2)
  {
  double res;
  int i;
  double Average1=0.,Average2=0.;
  double Delta1,Delta2,sumD1D2=0.,sumD1_2=0.,sumD2_2=0.;
  
  //    
  for(i=0;i<CorrelationBars;i++)   //       
    {
    Average1=Average1+iCloseSymbols[i][Symbol1];
    Average2=Average2+iCloseSymbols[i][Symbol2];
    }
  Average1=Average1/CorrelationBars;
  Average2=Average2/CorrelationBars;
  
  //  
  for(i=0;i<CorrelationBars;i++)   //       
    {
    Delta1=iCloseSymbols[i][Symbol1]-Average1;
    Delta2=iCloseSymbols[i][Symbol2]-Average2;
    sumD1D2=sumD1D2+Delta1*Delta2;
    sumD1_2=sumD1_2+Delta1*Delta1;
    sumD2_2=sumD2_2+Delta2*Delta2;
    }
  
  //   
  res=sumD1D2/MathSqrt(sumD1_2*sumD2_2);
  
  return(res);
  }

//---------------------------------------------------------------------------

